#import "ProgramTextController.h"
#include <unistd.h>

@implementation ProgramTextController

NSTimer *myTimer; 

- (IBAction)updateMainText:(id)sender newText:(id)inString
{
[mainTextOutlet insertText:inString];

}

- (void)awakeFromNib
{
/*main.m should have changed the default directory to the appropriate directory*/
if (!access("nodelist_ip", R_OK)) {
    /* Using a NSTimer so that the event loop will make the window appear
    and settle any other user-interface details.  */ 
    myTimer = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(fireRoutine:) userInfo:0 repeats:false]; 
    
    }
else {/* not found */
    [mainTextOutlet insertText:@"No node list information found.  \n\nPlease use Pooch to run this application in parallel.  \nSee http://daugerresearch.com/ for more details.\n\nThis application will terminate in 10 seconds.  \n"];
    myTimer = [NSTimer scheduledTimerWithTimeInterval:10.0 target:self selector:@selector(terminateRoutine:) userInfo:0 repeats:false]; 
    }

}

- (void)updateText:(id)inString
{
[mainTextOutlet insertText:inString];
}

- (void)fireRoutine:(NSTimer*)theTimer
    {
    int out; 
    printf("timer fired\n");
    
/* note that we call cmain, instead of main to distinguish it from this one */
    out = cmain(0, NULL, mainTextOutlet); 
    remove("nodelist_ip"); 
    
    [NSApp terminate:self]; /* "I cannot self-terminate..." */
    }
    
- (void)terminateRoutine:(NSTimer*)theTimer
    {
    printf("terminate timer fired\n");
    
    [NSApp terminate:self]; /* "I cannot self-terminate..." */
    }
    
@end

int cocoaprintf(void *mainTextOutlet, char *inS)
{int out=0; 
if (inS) {
    printf(inS); 
    [mainTextOutlet insertText:[NSString stringWithCString:inS]]; 
    }
else out=-1; 
return out; 
}

